#! /usr/bin/python

# xml to DocBook file converter v0.5 [1]
# copyright (c) 1999 Frederic Peters <fpeters@win.be>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# [1]: it works with GGAD; I don't know about other document written
# using xml (if you have some feel free to send them to me so I can
# improve this script 'portability')


# TODO:
#  - use DocBook tags for function synopsis

import xmllib
import string

def start_include(self, tag, attributes):
	if ( len(self.sections_stack) == 1 and self.common_flag == 1 ):
		self.f.write('</partintro>\n')
		self.common_flag = 0
	self.include_this = 1

def end_include(self, tag):
	pass

def start_author(self, tag, attributes):
	self.f.write ( '<bookinfo>' )
	# FIXME: it doesn't know about the differences between first and last
	# names
	self.f.write ( '<author><firstname>' )

def end_author(self, tag):
	self.f.write ( '</firstname></author>' )
	self.f.write ( '</bookinfo>' )

def start_part(self, tag, attributes):
	self.f.write ( '<part><title>' )

def end_part(self, tag):
	pass

def start_para(self, tag, attributes):
	if ( len(self.sections_stack) == 1 and self.common_flag == 0 ):
		self.f.write('<partintro>\n')
		self.common_flag = 1
	self.f.write ( '<para>' )

def end_para(self, tag):
	self.f.write ( '</para>' )

def start_section(self, tag, attributes):
	sect_dict = { 'part':0, 'chapter':1, 'sect1':2, 'sect2':3, 'sect3':4 }
	t_dict = {	'part' : 'part',
			'hb' : 'chapter',
			'hc' : 'sect1',
			'hd' : 'sect2',
			'he' : 'sect3',
		}
	ttag = t_dict[tag]
	#print self.sections_stack
	while ( 1 and len(self.sections_stack) != 0 ):
		if ( sect_dict[ self.sections_stack[-1] ] >= sect_dict[ttag] ):
			self.f.write('</' + self.sections_stack[-1] + '>')
			self.sections_stack = self.sections_stack[:-1]
		else:
			break
	self.f.write ( '<' + ttag + '><title>' )
	self.title_counter = 2
	self.sections_stack.append(ttag)
	self.last_label = ''

def end_section(self, tag):
	if ( len(self.last_label) == 0 ):
		return
	# you'd better close your eyes
	if ( self.f.tell() < 80 ):
		self.f.seek( - self.f.tell() , 1)
	else:
		self.f.seek ( -80, 1)
	line = self.f.read(90)
	back = len(line)
	t_dict = {	'part' : 'part',
			'hb' : 'chapter',
			'hc' : 'sect1',
			'hd' : 'sect2',
			'he' : 'sect3',
		}
	ttag = t_dict[tag]
	lookedfor = '<' + ttag + '>'
	ind = string.rfind(line, lookedfor)
	label = string.replace(self.last_label, ':', '-')
	self.f.seek( -back , 1)
	self.f.write( line[:ind + len(lookedfor)-1] + ' id="' + \
			label + '">' + line[ ind + len(lookedfor) : ] )
#	print line[:ind + len(lookedfor)-1] + ' id="' + \
#			label + '">' + line[ ind + len(lookedfor) : ]

def start_maclist(self, tag, attributes):
	self.in_memory = 1
	self.im_lines = []

def end_commonlist(self, tag):
	for i in range(0, len(self.im_lines) ):
		self.im_lines[i] = string.lstrip( self.im_lines[i] )
	while ( 1 ):
		try:
			self.im_lines.remove('\n')
		except ValueError:
			break
	while ( 1 ):
		try:
			self.im_lines.remove('')
		except ValueError:
			break
	while ( 1 ):
		try:
			self.im_lines.remove(' ')
		except ValueError:
			break
	id = self.last_label
#	for line in self.im_lines:
#		if ( id == '__' ):
#			id = line
#			break
#		if ( line[:2] == '__' ):
#			id = line
#	self.im_lines.remove('__')
#	self.im_lines.remove(id)
	title = ''
	for line in self.im_lines [ self.im_lines.index('<title>')+1 : \
					self.im_lines.index('</title>')]:
		title = title + line
	del(self.im_lines[ self.im_lines.index('<title>') : \
				self.im_lines.index('</title>')+1 ] )
	id = string.replace(id, '_', '-' )
	id = string.replace(id, ':', '-' )
		
	if ( tag == 'maclist' ):
		tagtype = 'ml-'
	elif ( tag == 'funclist' ):
		tagtype = 'fl-'
	else:
		tagtype = ''
	self.im_lines.insert(0, '<table id="' + id + '">\n')
	self.im_lines.insert(1, '<title>' + title + '</title>\n')
	self.im_lines.insert(2, '<tgroup cols="1">\n' )
	i=4
	while ( 1 ):
		i = i + 1
		if ( self.im_lines[i][-9:] == '</thead>\n' ):
			self.im_lines.insert(i+1, '<tbody>')
			break
	self.im_lines.append('</tbody></tgroup></table>\n')
	

def end_maclist(self, tag):
	end_commonlist(self, tag)

	i = 0
	while ( 1 ):
		i = i + 1
		if ( self.im_lines[i][:8] == '</tbody>' ):
			break
		if ( self.im_lines[i][:5] == '<row>' ):
			if ( self.im_lines[i+2][:8] == '</entry>' ):
				continue
			self.im_lines[i+1] = self.im_lines[i+1] + '('
			j = i+2
			while ( self.im_lines[j+1][:8] != '</entry>' ):
				self.im_lines[j] = self.im_lines[j] + ', '
				j = j + 1
			self.im_lines[j] = self.im_lines[j] + ')'
	
	self.f.writelines(self.im_lines)
	self.in_memory = 0

def start_funclist(self, tag, attributes):
	self.in_memory = 1
	self.im_lines = []

def end_funclist(self, tag):
	end_commonlist(self, tag)
	
	i = 0
	while ( 1 ):
		i = i + 1
		if ( self.im_lines[i][:8] == '</tbody>' ):
			break
		if ( self.im_lines[i][:5] == '<row>' ):
			self.im_lines[i+1] = self.im_lines[i+1] + ' '
			if ( self.im_lines[i+3][:8] == '</entry>' ):
				self.im_lines[i+2] = self.im_lines[i+2] + '()'
				continue
			self.im_lines[i+2] = self.im_lines[i+2] + '('
			j = i+2
			while ( self.im_lines[j+1][:8] != '</entry>' ):
				if ( self.im_lines[j-1] == ', ' ):
					self.im_lines[j] = self.im_lines[j]+' '
				j = j + 1
			self.im_lines[j] = self.im_lines[j] + ')'
			del(self.im_lines[i+3])
			
	self.f.writelines(self.im_lines)
	self.in_memory = 0

def start_table(self, tag, attributes):
	self.in_memory = 1
	self.im_lines = [ ]
	self.last_label = ''

def end_table(self, tag):
	for i in range(0, len(self.im_lines) ):
		self.im_lines[i] = string.lstrip( self.im_lines[i] )
	while ( 1 ):
		try:
			self.im_lines.remove('\n')
		except ValueError:
			break
	while ( 1 ):
		try:
			self.im_lines.remove('')
		except ValueError:
			break
	while ( 1 ):
		try:
			self.im_lines.remove(' ')
		except ValueError:
			break
	
	if ( len(self.last_label) > 0 ):
		id = string.replace(self.last_label, ':', '-')
		id = string.replace(id, '_', '-')
		self.im_lines.insert(0, '<table id="' + id + '">\n')
	else:
		self.im_lines.insert(0, '<table>\n')
	self.im_lines.append('\n</tbody></tgroup></table>\n')
	nb_cols = 0
	i = self.im_lines.index('<entry>')
	while ( self.im_lines[i][:6] != '</row>' ):
		if ( self.im_lines[i] == '<entry>' ):
			nb_cols = nb_cols + 1
		i = i + 1
	self.im_lines.insert( self.im_lines.index('<thead><row>'), \
			'<tgroup cols="' + `nb_cols` + '">\n' )
	self.im_lines.insert( self.im_lines.index('</row></thead>\n')+1, \
			'<tbody>' )
	self.f.writelines(self.im_lines)
	self.in_memory = 0

def start_simple(self, tag, attributes):
	if ( self.hide == 1 ):
		return
	if ( self.in_memory == 0 ):
		self.f.write ( self.direct_translations[tag][0] )
	else:
		self.im_lines.append(self.direct_translations[tag][0] )

def end_simple(self, tag):
	if ( self.hide == 1 ):
		return
	if ( self.in_memory == 0 ):
		self.f.write ( self.direct_translations[tag][1] )
	else:
		self.im_lines.append(self.direct_translations[tag][1] )

def start_hide(self, tag, attributes):
	self.hide = 1

def end_hide(self, tag):
	self.hide = 0

def start_imagefile(self, tag, attributes):
	self.common_flag = 2

def end_imagefile(self, tag):
	self.common_flag = 0

def start_figure(self, tag, attribute):
	self.in_memory = 1
	self.last_label = ''
	self.im_lines = []

def end_figure(self, tag):
	self.im_lines.append('</figure>\n')
	if ( len(self.last_label) == 0 ):
		self.im_lines.insert(0, '<figure>\n')
	else:
		id = string.replace(self.last_label, ':', '-')
		id = string.replace(id, '_', '-')
		self.im_lines.insert(0, '<figure id="' + id + '">\n')
	self.f.writelines(self.im_lines)
	self.in_memory = 0
	self.last_label = ''

def start_label(self, tag, attributes):
	self.common_flag = 3
	self.last_label = ''

def end_label(self, tag):
	self.common_flag = 0

def start_xref(self, tag, attributes):
	self.common_flag = 4

def end_xref(self, tag):
	self.common_flag = 0

def start_url(self, tag, attributes):
	self.common_flag = 5

def end_url(self, tag):
	self.common_flag = 0

class XMLBookParser(xmllib.XMLParser):
	filename = ''
	f = None
	include_this = 0
	xml_included = []
	sections_stack = []
	title_counter = 0
	hide = 0
	in_memory = 0
	im_lines = []
	common_flag = 0
	last_label = ''

	known_unknown = {}
	direct_translations = \
		{ \
		# things to skip
		'fake' :	( '' , '' ),
		'ha' :		( '' , '' ),
#		'url' :		( '' , '' ),
		'macname' :	( '' , '' ),
		'argname' :	( '' , '' ),
		'void' :	( '' , '' ),
		'retval' :	( '' , '' ),
		'funcname' :	( '' , '' ),
		'argtype' :	( '' , '' ),
		# things like <gnome/>
		'gnome' :	( 'Gnome ' , '' ),
		'gtk' :		( 'Gtk+ ' , '' ),
		'unix' :	( 'UNIX ' , '' ),
		'cxx' :		( 'C++ ' , '' ),
		'orbit' :	( 'ORBit ' , '' ),
		'imlib' :	( 'IMlib ' , '' ),
		'glib' :	( 'GLIB ' , '' ),
		'gdk' :		( 'GDK ' , '' ),
		# _real_ translations
		'book' : ( '<book>\n', '</part></book>\n' ),
		'title' : ( '<title>', '</title>\n' ),
		'function' : ( '<function>', '</function>' ),
		'bl' : ( '<itemizedlist>', '</itemizedlist>' ),
		'lb' : ( '<listitem><para>', '</para></listitem>' ),
		'nl' : ( '<orderedlist>', '</orderedlist>' ),
		'ln' : ( '<listitem><para>', '</para></listitem>' ),
		'c' : ( '<type>', '</type>' ), # not sure
		'widget' : ( '<type>', '</type>' ),
#		'p' : ( '<para>', '</para>' ),
		'module' : ( '<application>', '</application>' ),
		'code' : ( '<programlisting>', '</programlisting>' ),
		'em' : ( '<emphasis>', '</emphasis>' ),
		'term' : ( '<firstterm>', '</firstterm>' ),
		'header' : ( '<filename>', '</filename>' ),
		'tt' : ( '<command>', '</command>' ), # nothing better ?
		'macro' : ( '<function>', '</function>' ),
		'file' : ( '<filename>', '</filename>' ),
		'signal' : ( '<function>', '</function>' ),
		'mfour' : ( '<function>', '</function>' ),
		'caption' : ( '<title>', '</title>' ),
		'macheader' : ( '<thead><row><entry>#include &lt;', \
				'&gt;</entry></row></thead>\n' ),
		'macsyn' : ( '<row><entry>', '</entry></row>\n' ),
		'funcheader' : ( '<thead><row><entry>#include &lt;', \
				'&gt;</entry></row></thead>\n' ),
		'funcsyn' : ( '<row><entry>', '</entry></row>\n' ),
		'arg' : ( ', ', '' ),
		'tablehead' : ( '<thead><row>', '</row></thead>\n' ),
		'tablecell' : ( '<entry>', '</entry>' ),
		'tablebody' : ( '<row>', '</row>\n' ),
		# misc
		'label' : ('__', ''),
		}

	elements = {	'include'	: ( start_include, end_include ),
#			'title'		: ( start_title, end_title ),
			'author'	: ( start_author, end_author ),
			'part'		: ( start_section, end_section ),
			'hb'		: ( start_section, end_section ),
			'hc'		: ( start_section, end_section ),
			'hd'		: ( start_section, end_section ),
			'he'		: ( start_section, end_section ),
			'qq'		: ( start_hide, end_hide ),
			'pd'		: ( start_hide, end_hide ),
			'label'		: ( start_label, end_label ),
			'maclist'	: ( start_maclist, end_maclist ),
			'funclist'	: ( start_funclist, end_funclist ),
			'p'		: ( start_para, end_para ),
			'imagefile'	: ( start_imagefile, end_imagefile ),
			'table'		: ( start_table, end_table ),
			'mlref'		: ( start_xref, end_xref ),
			'flref'		: ( start_xref, end_xref ),
			'chapref'	: ( start_xref, end_xref ),
			'secref'	: ( start_xref, end_xref ),
			'figref'	: ( start_xref, end_xref ),
			'tabref'	: ( start_xref, end_xref ),
			'figure'	: ( start_figure, end_figure ),
			'url'		: ( start_url, end_url ),
		   }
	
	def handle_xml (self, encoding, standalone):
		self.f = open('DocBook/' + self.filename, 'w+')
		if ( standalone == 'no' ):
			return
		self.f.write('<!doctype book PUBLIC "-//Davenport//DTD ' + \
				'DocBook V3.0//EN" [\n]>' )

	def handle_starttag(self, tag, method, attributes):
		if ( self.title_counter > 1 ):
			self.title_counter = self.title_counter + 1
		method(self, tag, attributes)
	
	def handle_endtag(self, tag, method):
		if ( self.title_counter > 1 ):
			self.title_counter = self.title_counter - 1
		method(self, tag)
	
	def unknown_starttag(self, tag, attributes):
		if ( self.direct_translations.has_key(tag) ):
			start_simple(self, tag, attributes)
			return
		if ( self.known_unknown.has_key(tag) ):
			pass
		else:
			print 'FIXME:', tag, 'is an unknown tag.'
			self.known_unknown[tag] = 1
	
	def unknown_endtag(self, tag ):
		if ( self.direct_translations.has_key(tag) ):
			end_simple(self, tag)
			return
		
	def handle_data (self, data):
		if ( self.hide == 1 ):
			return
		if ( self.common_flag == 2 and len(data) > 2 ):
			# FIXME:
			#  I'd like to support png files but (last time I
			#  checked) DocBook didn't like them.
			giffile = data[:-3] + 'gif'
			data = '<graphic fileref="' + giffile + \
					'" format="gif"></graphic>'
		if ( self.common_flag == 3 and len(data) > 2 ):
			self.last_label = data
			return
		if ( self.common_flag == 4 and len(data) > 2 ):
			dest = string.replace(data, ':', '-')
			dest = string.replace(dest, '_', '-')
			data = '<xref linkend="' + dest + '">'
		if ( self.common_flag == 5 and len(data) > 2 ):
			data = '<ulink url="' + data + '">' + data + '</ulink>'
		if ( self.include_this == 1 ):
			if ( len(data) == 1 ):
				return
			if ( data[-1] == '\n' ):
				data = data[:-1]
			if ( data[-3:] == 'xml' ):
				#print 'adding', data, 'to included files'
				self.xml_included.append(data)
				self.f.write('&' + data[:-4] + ';' )
			else:
#				print 'including', data
				f = open(data)
				line = f.readline()
				while ( len(line) > 0 ):
					self.f.write(line)
					line = f.readline()
				f.close()
			self.include_this = 0
			return
		if ( self.title_counter == 1 ):
			self.f.write(data)
			self.f.write('</title>')
			self.title_counter = 0
			return
		if ( self.in_memory == 0 ):
			self.f.write(data)
		else:
			self.im_lines.append(data)

def convert_one(filename):
	print 'Processing', filename
	f = open(filename)
	lines = f.readlines()
	f.close()
	sgmlfile = XMLBookParser()
	sgmlfile.filename = filename[:-3] + 'sgml'
	for line in lines:
		line = string.replace(line, '&', '&amp;' )
		sgmlfile.feed(line)
	sgmlfile.close()
	sgmlfile.f.close()
	for file in sgmlfile.xml_included:
		print 'Processing', file
		f = open(file)
		lines = f.readlines()
		f.close()
		sfile = XMLBookParser()
		sfile.filename = file[:-3] + 'sgml'
		sfile.f = open('DocBook/' + sfile.filename, 'w+' )
		sfile.sections_stack = [ 'part' ]
		lines.insert(0, '<fake>\n')
		lines.append('</fake>\n\n')
		for line in lines:
			line = string.replace(line, '&', '&amp;' )
			sfile.feed(line)
		sfile.close()
		sfile.f.close()

	f = open('DocBook/' + sgmlfile.filename)
	lines = f.readlines()
	f.close()

	for file in sgmlfile.xml_included:
		lines.insert( 1, \
			'<!entity ' + file[:-4] + ' SYSTEM "' + \
				file[:-4] + '.sgml">\n' )
	f = open('DocBook/' + sgmlfile.filename, 'w')
	f.writelines(lines)
	f.close()


convert_one('book.xml')

